"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_assess.types import BaseModel
from codat_assess.utils import serialize_decimal, validate_decimal
from decimal import Decimal
import pydantic
from pydantic.functional_serializers import PlainSerializer
from pydantic.functional_validators import BeforeValidator
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class DataIntegrityByCountTypedDict(TypedDict):
    match_percentage: NotRequired[Decimal]
    r"""The percentage of records of the type specified in the route which have a match."""
    matched: NotRequired[Decimal]
    r"""The number of records of the type specified in the route which do have a match."""
    total: NotRequired[Decimal]
    r"""The total of unmatched and matched."""
    unmatched: NotRequired[Decimal]
    r"""The number of records of the type specified in the route which don't have a match."""


class DataIntegrityByCount(BaseModel):
    match_percentage: Annotated[
        Annotated[
            Optional[Decimal],
            BeforeValidator(validate_decimal),
            PlainSerializer(serialize_decimal(False)),
        ],
        pydantic.Field(alias="matchPercentage"),
    ] = None
    r"""The percentage of records of the type specified in the route which have a match."""

    matched: Annotated[
        Optional[Decimal],
        BeforeValidator(validate_decimal),
        PlainSerializer(serialize_decimal(False)),
    ] = None
    r"""The number of records of the type specified in the route which do have a match."""

    total: Annotated[
        Optional[Decimal],
        BeforeValidator(validate_decimal),
        PlainSerializer(serialize_decimal(False)),
    ] = None
    r"""The total of unmatched and matched."""

    unmatched: Annotated[
        Optional[Decimal],
        BeforeValidator(validate_decimal),
        PlainSerializer(serialize_decimal(False)),
    ] = None
    r"""The number of records of the type specified in the route which don't have a match."""
