"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .enhancedreportaccountcategory import (
    EnhancedReportAccountCategory,
    EnhancedReportAccountCategoryTypedDict,
)
from .enhancedreportinfo import EnhancedReportInfo, EnhancedReportInfoTypedDict
from codat_assess.types import BaseModel
from codat_assess.utils import serialize_decimal, validate_decimal
from decimal import Decimal
import pydantic
from pydantic.functional_serializers import PlainSerializer
from pydantic.functional_validators import BeforeValidator
from typing import List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class ReportItemTypedDict(TypedDict):
    account_category: NotRequired[EnhancedReportAccountCategoryTypedDict]
    account_id: NotRequired[str]
    r"""The unique account ID."""
    account_name: NotRequired[str]
    r"""Name of the account."""
    balance: NotRequired[Decimal]
    r"""Balance of the account as reported on the profit and loss or Balance sheet."""
    date_: NotRequired[str]
    r"""In Codat's data model, dates and times are represented using the <a class=\"external\" href=\"https://en.wikipedia.org/wiki/ISO_8601\" target=\"_blank\">ISO 8601 standard</a>. Date and time fields are formatted as strings; for example:

    ```
    2020-10-08T22:40:50Z
    2021-01-01T00:00:00
    ```



    When syncing data that contains `DateTime` fields from Codat, make sure you support the following cases when reading time information:

    - Coordinated Universal Time (UTC): `2021-11-15T06:00:00Z`
    - Unqualified local time: `2021-11-15T01:00:00`
    - UTC time offsets: `2021-11-15T01:00:00-05:00`

    > Time zones
    >
    > Not all dates from Codat will contain information about time zones.
    > Where it is not available from the underlying platform, Codat will return these as times local to the business whose data has been synced.
    """


class ReportItem(BaseModel):
    account_category: Annotated[
        Optional[EnhancedReportAccountCategory], pydantic.Field(alias="accountCategory")
    ] = None

    account_id: Annotated[Optional[str], pydantic.Field(alias="accountId")] = None
    r"""The unique account ID."""

    account_name: Annotated[Optional[str], pydantic.Field(alias="accountName")] = None
    r"""Name of the account."""

    balance: Annotated[
        Optional[Decimal],
        BeforeValidator(validate_decimal),
        PlainSerializer(serialize_decimal(False)),
    ] = None
    r"""Balance of the account as reported on the profit and loss or Balance sheet."""

    date_: Annotated[Optional[str], pydantic.Field(alias="date")] = None
    r"""In Codat's data model, dates and times are represented using the <a class=\"external\" href=\"https://en.wikipedia.org/wiki/ISO_8601\" target=\"_blank\">ISO 8601 standard</a>. Date and time fields are formatted as strings; for example:

    ```
    2020-10-08T22:40:50Z
    2021-01-01T00:00:00
    ```



    When syncing data that contains `DateTime` fields from Codat, make sure you support the following cases when reading time information:

    - Coordinated Universal Time (UTC): `2021-11-15T06:00:00Z`
    - Unqualified local time: `2021-11-15T01:00:00`
    - UTC time offsets: `2021-11-15T01:00:00-05:00`

    > Time zones
    >
    > Not all dates from Codat will contain information about time zones.
    > Where it is not available from the underlying platform, Codat will return these as times local to the business whose data has been synced.
    """


class EnhancedReportTypedDict(TypedDict):
    report_info: NotRequired[EnhancedReportInfoTypedDict]
    report_items: NotRequired[List[ReportItemTypedDict]]
    r"""An array of report items."""


class EnhancedReport(BaseModel):
    report_info: Annotated[
        Optional[EnhancedReportInfo], pydantic.Field(alias="reportInfo")
    ] = None

    report_items: Annotated[
        Optional[List[ReportItem]], pydantic.Field(alias="reportItems")
    ] = None
    r"""An array of report items."""
